<?php

//------------------------------------------------------------------------
//              Process xml document
//------------------------------------------------------------------------

function convert_xml($rest, $callback, $format, $curl = 0)
{

global $xml_array, $tree, $tree_levels, $grouping, $tag_data, $callback_func, $stop_parsing;

$xml_array = array();

$tree = '/'.$format;
$tree_levels = sizeof(explode("/",$tree))-1;
$grouping = false;
$tag = false;
$tag_data = "";
$callback_func = $callback;
$stop_parsing = false;

$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");


if (function_exists('curl_init'))
   {
   $ch = curl_init();
   $timeout = 5; // set to zero for no timeout
   curl_setopt ($ch, CURLOPT_URL, $rest);
   curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
   curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
   $file_contents = curl_exec($ch);
   curl_close($ch);
   }
else
   {
   $fp = @fopen("$rest","r");
   if (!$fp) return;
   $file_contents = '';
   while (!feof($fp))
      {
      $file_contents .= fread($fp, 2048);
      }

   fclose($fp);
   }    


xml_parse($xml_parser, $file_contents)
 or die(sprintf("XML error: %s at line %d", 
 xml_error_string(xml_get_error_code($xml_parser)), 
 xml_get_current_line_number($xml_parser)));

xml_parser_free($xml_parser);

}


//------------------------------------------------------------------------
//              Start of xml element
//------------------------------------------------------------------------

function startElement($parser, $name, $attrs)
{

   global $xml_level, $xml_curr_path, $tree, $tree_levels, $grouping, $tag_data, $tag, $xml_array;
   
   $xml_level++;
   $xml_curr_path .= '/'.$name;

   if ($grouping)
      {
      $tag = true;
      foreach($attrs as $key => $value)
         {
         $keys = "$name:$key";
         $xml_array[$keys] = $value;
         }
      }

   if ($xml_curr_path == $tree && $xml_level == $tree_levels)
      {
      foreach($attrs as $key => $value)
         {
         $keys = "$name:$key";
         $xml_array[$keys] = $value;
         }
      $grouping = true;
      $tag_data = "";
      }

}


//------------------------------------------------------------------------
//              End of xml element
//------------------------------------------------------------------------

function endElement($parser, $name)
{

   global $xml_level, $xml_curr_path, $tree, $tree_levels, $grouping, $tag_data, $xml_array, $callback_func, $stop_parsing;
   global $tag;

   $xml_level--;
   $xml_curr_path = substr($xml_curr_path,0,strlen($xml_curr_path) - strlen($name)-1);
   $tag = false;

   if ($xml_curr_path == $tree && $xml_level == $tree_levels && $grouping == true)
      {
      $xml_array[$name] = $tag_data;
      $tag = false;
      }
      
   if ($xml_level == $tree_levels - 1 && $grouping == true && !$stop_parsing)
      {
      $stop_parsing = call_user_func($callback_func, $xml_array);
      $grouping = false;
      $tag = false;
      $xml_array = array();
      }
      
   $tag_data = "";
	
}

//------------------------------------------------------------------------
//              Character Data (the text between the tags!)
//------------------------------------------------------------------------

function characterData($parser, $data)
{

   global $grouping, $tag_data, $tag;
   
   if ($grouping == true && $tag == true)
      {
      $tag_data .= $data;
      }
      
}
?>
